<?php
/**
 * Copyright © 2016 Filoblu S.r.l. All rights reserved.
 */
namespace FiloBlu\OrderAdditionalData\Model;

/**
 * OAD Order Additional Data
 */
class OrderData extends \Magento\Framework\Model\AbstractModel implements \FiloBlu\OrderAdditionalData\Api\OrderDataInterface
{

    /** @var \Magento\Framework\Serialize\SerializerInterface */
    protected $_serializer;

    /**
     * OrderData constructor.
     * @param \Magento\Framework\Model\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Magento\Framework\Serialize\SerializerInterface $serializer
     * @param \Magento\Framework\Model\ResourceModel\AbstractResource|null $resource
     * @param \Magento\Framework\Data\Collection\AbstractDb|null $resourceCollection
     * @param array $data
     */
    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \Magento\Framework\Serialize\SerializerInterface $serializer,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {
        $this->_serializer = $serializer;
        parent::__construct($context, $registry, $resource, $resourceCollection, $data);
    }

    protected function _construct()
    {
        $this->_init(\FiloBlu\OrderAdditionalData\Model\ResourceModel\OrderData::class);
    }

    /**
     * @deprecated not used
     * Return additional data
     *
     * @return mixed
     */
    public function getDataArray(){
        return $this->_serializer->unserialize($this->getAdditionalData());
    }

}
